diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
index 7a18fc5e2..5eaa60091 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
@@ -10,6 +10,8 @@ import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHead> {
@@ -32,25 +34,25 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        return renderPistonHead(tessellator, block, x, y, z, true);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        return renderPistonHead(tessellator, worldSource, block, x, y, z, true);
     }
-    public void renderPistonHeadNoCulling(Tessellator tessellator, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
+    public void renderPistonHeadNoCulling(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
         renderBlocks.renderAllFaces = true;
-        renderPistonHead(tessellator, block, x, y, z, flag);
+        renderPistonHead(tessellator, worldSource, block, x, y, z, flag);
         renderBlocks.renderAllFaces = false;
     }
     public void setFaceTextureOverride(@Nullable IconCoordinate faceTexture){
         faceTextureOverride = faceTexture;
     }
-    protected boolean renderPistonHead(Tessellator tessellator, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
-        int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    protected boolean renderPistonHead(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
+        int metadata = worldSource.getBlockMetadata(x, y, z);
         Direction direction = BlockLogicPistonHead.getDirectionFromMeta(metadata);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
         }else {
-        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
         }
         float f1 = flag ? 1.0F : 0.5F;
         double width = flag ? 1 : 1/2d;
@@ -61,7 +63,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 3;
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
-                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F), x, y, z);
                 renderHeadTopBottom(tessellator, x + 0.375F, x + 0.625F, y + headThickness, y + headThickness + f1, z + 0.625F, z + 0.625F, brightness * 0.8F, width);
                 renderHeadTopBottom(tessellator, x + 0.625F, x + 0.375F, y + headThickness, y + headThickness + f1, z + 0.375F, z + 0.375F, brightness * 0.8F, width);
                 renderHeadTopBottom(tessellator, x + 0.375F, x + 0.375F, y + headThickness, y + headThickness + f1, z + 0.375F, z + 0.625F, brightness * 0.6F, width);
@@ -69,7 +71,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 break;
 
             case UP: // TOP
-                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
                 renderHeadTopBottom(tessellator, x + 0.375F, x + 0.625F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.625F, z + 0.625F, brightness * 0.8F, width);
                 renderHeadTopBottom(tessellator, x + 0.625F, x + 0.375F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.375F, z + 0.375F, brightness * 0.8F, width);
                 renderHeadTopBottom(tessellator, x + 0.375F, x + 0.375F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.375F, z + 0.625F, brightness * 0.6F, width);
@@ -79,7 +81,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
             case NORTH: // NORTH
                 renderBlocks.uvRotateSouth = 1;
                 renderBlocks.uvRotateNorth = 2;
-                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness), x, y, z);
                 renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.375F, y + 0.625F, y + 0.375F, z + headThickness, z + headThickness + f1, brightness * 0.6F, width);
                 renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.625F, y + 0.375F, y + 0.625F, z + headThickness, z + headThickness + f1, brightness * 0.6F, width);
                 renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.625F, y + 0.375F, y + 0.375F, z + headThickness, z + headThickness + f1, brightness * 0.5F, width);
@@ -91,7 +93,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateNorth = 1;
                 renderBlocks.uvRotateTop = 3;
                 renderBlocks.uvRotateBottom = 3;
-                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F), x, y, z);
                 renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.375F, y + 0.625F, y + 0.375F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.6F, width);
                 renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.625F, y + 0.375F, y + 0.625F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.6F, width);
                 renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.625F, y + 0.375F, y + 0.375F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.5F, width);
@@ -103,7 +105,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 2;
                 renderBlocks.uvRotateTop = 2;
                 renderBlocks.uvRotateBottom = 1;
-                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F), x, y, z);
                 renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.375F, y + 0.375F, z + 0.625F, z + 0.375F, brightness * 0.5F, width);
                 renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.625F, y + 0.625F, z + 0.375F, z + 0.625F, brightness, width);
                 renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.375F, y + 0.625F, z + 0.375F, z + 0.375F, brightness * 0.6F, width);
@@ -115,14 +117,14 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 1;
                 renderBlocks.uvRotateTop = 1;
                 renderBlocks.uvRotateBottom = 2;
-                renderStandardBlock(tessellator, AABB.getTemporaryBB(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
                 renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.375F, y + 0.375F, z + 0.625F, z + 0.375F, brightness * 0.5F, width);
                 renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.625F, y + 0.625F, z + 0.375F, z + 0.625F, brightness, width);
                 renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.375F, y + 0.625F, z + 0.375F, z + 0.375F, brightness * 0.6F, width);
                 renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.625F, y + 0.375F, z + 0.625F, z + 0.625F, brightness * 0.6F, width);
                 break;
         }
-        resetRenderBlocks();
+        renderBlocks.resetRenderBlocks();
         return true;
     }
     private void renderHeadTopBottom(Tessellator tessellator, double xMin, double xMax, double yMin, double yMax, double zMin, double zMax, float brightness, double width)
@@ -183,7 +185,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
         return false;
     }
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         Direction direction = BlockLogicPistonHead.getDirectionFromMeta(data);
         if(side.getDirection() == direction)
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
index 51d5e8862..0937562b6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPlanksPainted<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
@@ -21,7 +22,7 @@ public class BlockModelPlanksPainted<T extends BlockLogic> extends BlockModelSta
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
         return texCoords[meta & DyeColor.MASK_COLOR];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
index 7d14b6bd2..04576c568 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
@@ -8,6 +8,8 @@ import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPortal<T extends BlockLogicPortal> extends BlockModelTransparent<T> {
     protected IconCoordinate[] colors = new IconCoordinate[16];
@@ -19,7 +21,7 @@ public class BlockModelPortal<T extends BlockLogicPortal> extends BlockModelTran
         onRenderLayer(1);
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
     {
         if(blockAccess.getBlockId(x, y, z) == block.id())
         {
@@ -29,7 +31,7 @@ public class BlockModelPortal<T extends BlockLogicPortal> extends BlockModelTran
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         return colors[block.getLogic().fromMetadata(data).blockMeta];
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
index d4caf3503..a1ce327dc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
@@ -10,6 +10,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -20,24 +22,24 @@ public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         lavaFlag = true;
         boolean ob = renderBlocks.overbright;
         renderBlocks.overbright = true;
 //        block.setBlockBounds(0.005, 0.005, 0.005, 0.995, 0.995, 0.995);
-        boolean rendered = super.render(tessellator, x, y, z);
+        boolean rendered = super.render(tessellator, worldSource, x, y, z);
 
         renderBlocks.overbright = ob;
         lavaFlag = false;
 //        block.setBlockBounds(0, 0, 0, 1, 1, 1);
-        rendered |= super.render(tessellator, x, y, z);
+        rendered |= super.render(tessellator, worldSource, x, y, z);
         return rendered;
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if(renderBlocks.useInventoryTint) {
-            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
             float r = (float) (color >> 16 & 0xff) / 255F;
             float g = (float) (color >> 8 & 0xff) / 255F;
             float b = (float) (color & 0xff) / 255F;
@@ -68,13 +70,13 @@ public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         if (lavaFlag) return TextureRegistry.getTexture("minecraft:block/lava_still");
         return super.getBlockTextureFromSideAndMetadata(side, data);
     }
 
     @Override
-    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
         if (lavaFlag) return TextureRegistry.getTexture("minecraft:block/lava_still");
         return super.getBlockOverbrightTextureFromSideAndMeta(side, data);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index 23b3375e5..1f1c2e9b0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -10,6 +10,8 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard<T> {
     protected IconCoordinate railCurve = TextureRegistry.getTexture("minecraft:block/rail/turn");
@@ -27,8 +29,8 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int l = worldSource.getBlockMetadata(x, y, z);
         IconCoordinate i1 = getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
         if(renderBlocks.overrideBlockTexture != null)
         {
@@ -41,17 +43,17 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
 		float brightness = 1.0f;
 		if(LightmapHelper.isLightmapEnabled()) {
 			if(renderBlocks.overbright) {
-				tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Sky, x, y, z)));
+				tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, x, y, z)));
 			}else {
-				tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+				tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
 			}
 		}else {
 			if(!renderBlocks.overbright) {
-				brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+				brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
 			}
 		}
 		if(renderBlocks.overbright) {
-			i1 = getBlockOverbrightTexture(renderBlocks.blockAccess, x, y, z, 0);
+			i1 = getBlockOverbrightTexture(worldSource, x, y, z, Side.BOTTOM);
 			if(i1 == null) {
 				return false;
 			}
@@ -120,7 +122,7 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
         return false;
     }
     @Override
-    public IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, int side)
+    public @Nullable IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, @NotNull Side side)
     {
         if (!block.getLogic().isPowered || (blockAccess.getBlockMetadata(x, y, z) & 8) == 0) return null;
 
@@ -128,7 +130,7 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if(block == Blocks.RAIL_POWERED && (data & 8) != 0)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
index debb189ba..7eb2acc04 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
@@ -6,8 +6,10 @@ import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicRepeater;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
 	private static final BlockModelTorch<?> modelTorchActive = (BlockModelTorch<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_ACTIVE);
@@ -17,8 +19,8 @@ public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
         super(block);
     }
 
-    public boolean render(Tessellator tessellator, int x, int y, int z){
-        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z){
+        int meta = worldSource.getBlockMetadata(x, y, z);
         int i1 = meta & 3;
 
         switch(i1)
@@ -41,17 +43,17 @@ public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
         }
 
         int j1 = (meta & 0xc) >> 2;
-        renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
-        resetRenderBlocks();
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        renderBlocks.resetRenderBlocks();
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
+        	int lmc = block.getLightmapCoord(worldSource, x, y, z);
         	if(block.emission > 0) {
         		lmc = LightmapHelper.setBlocklightValue(lmc, 15);
         	}
         	tessellator.setLightmapCoord(lmc);
         }else {
-    		brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+    		brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
     		if(block.emission > 0 || Global.accessor.isFullbrightEnabled()) {
     			brightness = 1.0f;
     		}
@@ -100,7 +102,7 @@ public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
     {
         return true;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index 5317450e0..10f2577dd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -8,6 +8,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelRope<T extends BlockLogicRope>
 extends BlockModelStandard<T> {
@@ -16,8 +17,8 @@ extends BlockModelStandard<T> {
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        WorldSource world = renderBlocks.blockAccess;
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        WorldSource world = worldSource;
         Block<?> below;
         boolean hasFloor = (below = world.getBlock(x, y - 1, z)) != null && below.canPlaceOnSurface();
         boolean hasBlockNegX = canConnect(world, x, y, z, Side.WEST);
@@ -41,44 +42,44 @@ extends BlockModelStandard<T> {
         if (drawKnot)
         {
             bounds.set(0.5f - knotThickness, 0.5f - knotThickness, 0.5f - knotThickness, 0.5f + knotThickness, 0.5f + knotThickness, 0.5f + knotThickness);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
 
         if (hasBlockPosY)
         {
             bounds.set(0.5f - ropeThickness, 0.5f, 0.5f - ropeThickness, 0.5f + ropeThickness, 1, 0.5f + ropeThickness);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         if (hasBlockNegY)
         {
             bounds.set(0.5f - ropeThickness, 0, 0.5f - ropeThickness, 0.5f + ropeThickness, 0.5f, 0.5f + ropeThickness);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         if (hasBlockPosX)
         {
             bounds.set(0.5f, 0.5f - ropeThickness, 0.5f - ropeThickness, 1, 0.5f + ropeThickness, 0.5f + ropeThickness);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         if (hasBlockNegX)
         {
             bounds.set(0, 0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         if (hasBlockPosZ)
         {
             bounds.set(0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness, 1);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         if (hasBlockNegZ)
         {
             bounds.set(0.5f - ropeThickness, 0.5f - ropeThickness, 0f, 0.5f + ropeThickness, 0.5f + ropeThickness, 0.5f);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         if (hasFloor){
             bounds.set(0.5f - pileWidth, 0,0.5f - pileWidth, 0.5f + pileWidth, knotThickness, 0.5f + pileWidth);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
             bounds.set(0.5f - knotThickness, 0,0.5f - knotThickness, 0.5f + knotThickness, ropeThickness * 3, 0.5f + knotThickness);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
 
         return true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
index 16cf2cce7..78260b389 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelRotatable<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelRotatable(Block<T> block) {
@@ -12,7 +13,7 @@ public class BlockModelRotatable<T extends BlockLogic> extends BlockModelStandar
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         int index = Sides.orientationLookUp[6 * data + side.getId()];
         return blockTextures.get(Side.getSideById(index));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
index de48d025c..4155a8f1f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
@@ -5,6 +5,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelSeat<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelSeat(Block<T> block) {
@@ -12,17 +14,17 @@ public class BlockModelSeat<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
 
-        setRenderSide(Side.BOTTOM, false); // Set bottom face to not render
-        renderStandardBlock(tessellator, bounds, x, y, z); // Render seat
+        renderBlocks.setRenderSide(Side.BOTTOM, false); // Set bottom face to not render
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // Render seat
 
         // Set only the bottom face to render
         renderBlocks.renderBitMask = 0b111111;
-        setRenderSide(Side.BOTTOM, true);
+        renderBlocks.setRenderSide(Side.BOTTOM, true);
         bounds.minY += 0.1875D; // Shift the bottom face up
-        renderStandardBlock(tessellator, bounds, x, y, z); // Render Seat
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // Render Seat
 
         // Reset block values
         renderBlocks.renderBitMask = 0;
